Internationalization in React Chart

17 Aug 20267 minutes to read

Chart provides support for internationalization for the following elements:

  • Data label
  • Axis label
  • Tooltip

For more information about number and date formatting, see the internationalization guide: internationalization.

Note: The en-US locale and USD currency code are set as defaults. To use another culture, call loadCldr (and optionally setCulture) before the Chart renders. The currency used by the 'c' format is set via setCurrencyCode.

Globalization

Globalization is the process of designing and developing a component that works in different cultures/locales. Use the internationalization library to localize numbers, dates, and times in the Chart component — for example, by using the axis labelFormat property. You must call setCurrencyCode (and loadCldr for non en-US cultures) before the Chart mounts.

Numeric Format

The example below globalizes axis, point, and tooltip labels to the EUR currency format. To use a culture other than en-US, install @syncfusion/ej2-cldr-data and call loadCldr with the required JSON data before the Chart renders.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, ColumnSeries, Legend, Tooltip, DataLabel } from '@syncfusion/ej2-react-charts';
import { loadCldr, setCurrencyCode } from '@syncfusion/ej2-base';
// For non en-US cultures, install @syncfusion/ej2-cldr-data and load the CLDR JSON:
// import * as currencyData from '@syncfusion/ej2-cldr-data/main/en/currencies.json';
// import * as numbersData from '@syncfusion/ej2-cldr-data/main/en/numbers.json';
// loadCldr(currencyData, numbersData);
import { data } from './datasource';
setCurrencyCode('EUR');
function App() {
    const primaryxAxis = { edgeLabelPlacement: 'Shift', title: 'Years' };
    const primaryyAxis = { labelFormat: 'c', title: 'Sales Amount in Millions' };
    const marker = { dataLabel: { visible: true } };
    const tooltip = { enable: true, header: '${point.x}', format: '${point.y}' };
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Average Sales Comparison' tooltip={tooltip}>
      <Inject services={[ColumnSeries, Legend, Tooltip, DataLabel]}/>
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' name='Product X' type='Column' marker={marker}>
        </SeriesDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y1' name='Product Y' type='Column' marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
ColumnSeries, Legend, Tooltip, DataLabel, TooltipSettingsModel, AxisModel }
from'@syncfusion/ej2-react-charts';
import { loadCldr, setCurrencyCode } from '@syncfusion/ej2-base';
// For non en-US cultures, install @syncfusion/ej2-cldr-data and load the CLDR JSON:
// import * as currencyData from '@syncfusion/ej2-cldr-data/main/en/currencies.json';
// import * as numbersData from '@syncfusion/ej2-cldr-data/main/en/numbers.json';
// loadCldr(currencyData, numbersData);
import { data } from './datasource';
setCurrencyCode('EUR');

function App() {

  const primaryxAxis: AxisModel = { edgeLabelPlacement: 'Shift', title: 'Years' };
  const primaryyAxis: AxisModel = { labelFormat: 'c', title: 'Sales Amount in Millions' };
  const marker = { dataLabel: { visible: true } };
  const tooltip: TooltipSettingsModel = { enable: true, header: '${point.x}', format: '${point.y}' };

  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Average Sales Comparison'
      tooltip={tooltip}>
      <Inject services={[ColumnSeries, Legend, Tooltip, DataLabel]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y' name='Product X' type='Column'
          marker={marker}>
        </SeriesDirective>
        <SeriesDirective dataSource={data} xName='x' yName='y1' name='Product Y' type='Column'
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let data = [
    { x: 1900, y: 4,   y1: 2.6, y2: 2.8 }, 
    { x: 1920, y: 3.0, y1: 2.8, y2: 2.5 },
    { x: 1940, y: 3.8, y1: 2.6, y2: 2.8 }, 
    { x: 1960, y: 3.4, y1: 3,   y2: 3.2 },
    { x: 1980, y: 3.2, y1: 3.6, y2: 2.9 }, 
    { x: 2000, y: 3.9, y1: 3,   y2: 2 }
];
export let data: Object[] = [
    { x: 1900, y: 4,   y1: 2.6, y2: 2.8 }, 
    { x: 1920, y: 3.0, y1: 2.8, y2: 2.5 },
    { x: 1940, y: 3.8, y1: 2.6, y2: 2.8 }, 
    { x: 1960, y: 3.4, y1: 3,   y2: 3.2 },
    { x: 1980, y: 3.2, y1: 3.6, y2: 2.9 }, 
    { x: 2000, y: 3.9, y1: 3,   y2: 2 }
];

Internationalization in Angular Chart

31 Aug 20267 minutes to read

Chart supports internationalization for the following elements:

  • Data Label — formatted via the marker.dataLabel.format property.
  • Axis Label — formatted via the axis labelFormat property (for example, on primaryXAxis / primaryYAxis).
  • Tooltip — formatted via the tooltip.format property.

For more information about number and date formatting, see the EJ2 globalization guide: Internationalization guide.

Globalization

Globalization is the process of designing and developing a component that works in different cultures/locales. Use the internationalization library to localize numbers, dates, and times in the Chart component (for example, with the axis labelFormat property or the data label format).

Prerequisites

For non-en-US cultures, load the CLDR data, register the culture, and set the currency code once during application initialization, before any chart renders. Place these calls at the top of main.ts (or in a single bootstrap module imported before the chart):

import { loadCldr, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as numberingSystems from 'cldr-data/supplemental/numberingSystems.json';
import * as denumbers from 'cldr-data/main/de/numbers.json';
import * as detimeZoneNames from 'cldr-data/main/de/timeZoneNames.json';
import * as decurrencies from 'cldr-data/main/de/currencies.json';
import * as degregorian from 'cldr-data/main/de/ca-gregorian.json';

loadCldr(
    denumbers, detimeZoneNames, decurrencies, degregorian,
    numberingSystems
);
setCulture('de');
setCurrencyCode('EUR');

If you don’t need to change the culture from en-US, the bundled sample skips loadCldr/setCulture and calls only setCurrencyCode('EUR'). The axis will still render EUR because labelFormat: 'c' reads the globalized currency code set by setCurrencyCode. Add loadCldr/setCulture only when you need localized decimal/grouping separators or non-English culture output.

Numeric Format

Currency Format

The example below applies the EUR currency format to the y-axis labels by calling setCurrencyCode('EUR') and setting primaryYAxis.labelFormat to 'c'. To extend the same format to data labels and tooltips, see Customizing Tooltip and Data Label.

import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { LegendService, TooltipService, DataLabelService, ColumnSeriesService, DateTimeService } from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';
import { setCurrencyCode } from '@syncfusion/ej2-base';
setCurrencyCode('EUR');

@Component({
imports: [
         ChartModule
    ],

providers: [ LegendService, TooltipService, DataLabelService, ColumnSeriesService, DateTimeService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'[tooltip]='tooltip'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Column' xName='x' yName='y' name='Product X' [marker]='marker'></e-series>
            <e-series [dataSource]='chartData' type='Column' xName='x' yName='y1' name='Product Y ' [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public tooltip?: Object;
    public marker?: Object;
    public primaryYAxis?: Object;
    ngOnInit(): void {
        this.chartData = [
                { x: 1900, y: 4, y1: 2.6, y2: 2.8 }, { x: 1920, y: 3.0, y1: 2.8, y2: 2.5 },
                { x: 1940, y: 3.8, y1: 2.6, y2: 2.8 }, { x: 1960, y: 3.4, y1: 3, y2: 3.2 },
                { x: 1980, y: 3.2, y1: 3.6, y2: 2.9 }, { x: 2000, y: 3.9, y1: 3, y2: 2 }
        ];
        this.primaryXAxis = {
            title: 'Year',
            edgeLabelPlacement: 'Shift'
        };
        this.primaryYAxis = {
           title: 'Sales Amount in Millions',
           labelFormat: 'c'
        };
        this.tooltip = {
            enable: true, format: '${series.name} <br>${point.x} : ${point.y}'
        };
        this.marker = {
            dataLabel: {
                visible: true
            }
        };
        this.title = 'Average Sales Comparison';
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Date Format

To globalize axis labels to a culture-aware date format, set the axis valueType to DateTime and use a culture-aware labelFormat:

this.primaryXAxis = {
    title: 'Year',
    valueType: 'DateTime',
    labelFormat: 'd MMM yyyy'
};

This requires loadCldr and setCulture to be configured as shown in Prerequisites. To control whether the thousand separator is rendered, set the chart-level useGroupingSeparator property (default false):

this.useGroupingSeparator = true;

Customizing Tooltip and Data Label

The bundled snippet only currency-formats the axis. To apply the same format to data labels and tooltips, add format: 'c2' to the data label and an inline currency format token (for example, ${point.y:c2}) to the tooltip format string. The :c2 token uses the currency code set by setCurrencyCode(...) and renders two decimal places:

this.tooltip = {
    enable: true,
    format: '${series.name} <br>${point.x} : ${point.y:c2}'
};
this.marker = {
    dataLabel: {
        visible: true,
        format: 'c2'
    }
};

Troubleshooting

  • Axis/tooltip/data-label still display in en-US after setting currency code — setCurrencyCode('EUR') updates the global currency code, but en-US formatting (decimal point, thousand separator) is applied by default. Use labelFormat: 'c' on the axis (the bundled sample) and ${point.y:c2} (for tooltips) / format: 'c2' (for data labels) so the globalized currency symbol and culture-aware number formatting are rendered. To use a non-en-US culture for the formatter, also call loadCldr(...) and setCulture(...) before the chart is created.
  • Currency symbol missing — Confirm setCurrencyCode('EUR') is being called before the chart is created (for example, in main.ts rather than inside the component constructor). When using a non-en-US culture, also ensure the appropriate CLDR currencies JSON was passed to loadCldr.
  • Grouping separator (,) not visible — Verify that useGroupingSeparator is set to true on the chart (default is false).

See Also

For setup and installation, see Getting Started with Angular Chart.

Compatibility: The prerequisites and snippets use standalone Angular components and require Angular 17+ with @syncfusion/ej2-angular-charts 20.4.50 or higher.

Internationalization in Vue Chart

12 Aug 20268 minutes to read

Chart provides support for internationalization for the following elements:

  • Data label
  • Axis label
  • Tooltip

For more information about number and date formatting, see the internationalization guide: internationalization.

Globalization

Globalization is the process of designing and developing a component that works in different cultures/locales. Use the internationalization library to localize numbers, dates, and times in the Chart component, for example by using the axis labelFormat property.

Numeric Format

The example below globalize axis, point, and tooltip labels to the EUR currency format.

<template>
    <div id="app">
         <ejs-chart id="container" :title='title' :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :zoomSettings='zoom' :tooltip='tooltip'>
            <e-series-collection>
                <e-series :dataSource='seriesData' type='Column' xName='x' yName='y' name='Product X'  :marker='marker'> </e-series>
                <e-series :dataSource='seriesData' type='Column' xName='x' yName='y1' name='Product Y' :marker='marker'> </e-series>
            </e-series-collection>
        </ejs-chart>
    </div>
</template>
<script setup>
import { provide } from "vue";

import { ChartComponent as EjsChart, ColumnSeries, Category, Tooltip, Zoom, DataLabel,
SeriesCollectionDirective as ESeriesCollection, SeriesDirective as ESeries } from "@syncfusion/ej2-vue-charts";
import { setCurrencyCode } from '@syncfusion/ej2-base';
setCurrencyCode('EUR');

const seriesData = [
          { x: 1900, y: 4, y1: 2.6, y2: 2.8 }, { x: 1920, y: 3.0, y1: 2.8, y2: 2.5 },
          { x: 1940, y: 3.8, y1: 2.6, y2: 2.8 }, { x: 1960, y: 3.4, y1: 3, y2: 3.2 },
          { x: 1980, y: 3.2, y1: 3.6, y2: 2.9 }, { x: 2000, y: 3.9, y1: 3, y2: 2 }
            ];

const primaryXAxis = {
    title: 'Year',
    edgeLabelPlacement: 'Shift'
};

const primaryYAxis = {
   title: 'Sales Amount in Millions',
   labelFormat: 'c'
};

const zoom = {
    enableMouseWheelZooming: true,
    enableDeferredZooming: true,
    enablePinchZooming: true,
    enableSelectionZooming: true
};

const marker = {
    dataLabel: {
        visible: true
    }
};

const tooltip = {
    enable: true, format: '${point.x} : ${point.y}'
};

provide('chart',  [ColumnSeries, Category, Tooltip, Zoom, DataLabel]);

</script>
<style>
 #container {
     height: 350px;
 }
</style>
<template>
    <div id="app">
         <ejs-chart id="container" :title='title' :primaryXAxis='primaryXAxis' :primaryYAxis='primaryYAxis' :zoomSettings='zoom' :tooltip='tooltip'>
            <e-series-collection>
                <e-series :dataSource='seriesData' type='Column' xName='x' yName='y' name='Product X'  :marker='marker'> </e-series>
                <e-series :dataSource='seriesData' type='Column' xName='x' yName='y1' name='Product Y' :marker='marker'> </e-series>
            </e-series-collection>
        </ejs-chart>
    </div>
</template>
<script>

import { ChartComponent, ColumnSeries, Category, Tooltip, Zoom, DataLabel, SeriesCollectionDirective, SeriesDirective } from "@syncfusion/ej2-vue-charts";
import { setCurrencyCode } from '@syncfusion/ej2-base';
setCurrencyCode('EUR');

export default {
name: "App",
components: {
"ejs-chart":ChartComponent,
"e-series-collection":SeriesCollectionDirective,
"e-series":SeriesDirective,

},

  data() {
    return {
      seriesData: [
                { x: 1900, y: 4, y1: 2.6, y2: 2.8 }, { x: 1920, y: 3.0, y1: 2.8, y2: 2.5 },
                { x: 1940, y: 3.8, y1: 2.6, y2: 2.8 }, { x: 1960, y: 3.4, y1: 3, y2: 3.2 },
                { x: 1980, y: 3.2, y1: 3.6, y2: 2.9 }, { x: 2000, y: 3.9, y1: 3, y2: 2 }
              ],
        primaryXAxis: {
            title: 'Year',
            edgeLabelPlacement: 'Shift'
        },
        primaryYAxis: {
           title: 'Sales Amount in Millions',
           labelFormat: 'c'
        },
        zoom: {
            enableMouseWheelZooming: true,
            enableDeferredZooming: true,
            enablePinchZooming: true,
            enableSelectionZooming: true
        },
        marker: {
            dataLabel: {
                visible: true
            }
        },
        tooltip: {
            enable: true, format: '${point.x} : ${point.y}'
        },
      title: "Average Sales Comparison"
    };
  },
  provide: {
    chart: [ColumnSeries, Category, Tooltip, Zoom, DataLabel]
  }
};
</script>
<style>
 #container {
     height: 350px;
 }
</style>